// 
const { internalError, serverError, successCode } = require("../../controllers/statusCode");
const CURRENTDATE = require("../../controllers/todayDate");
const { AsyncHandeler } = require("../../utils/AsyncHandeller");
const { ApiError } = require("../../utils/ApiError");
const { ApiResponse } = require("../../utils/ApiResponce");
const conDB = require("../../db/database");


// const TableDataDelete = AsyncHandeler(async(req, res)=>{
//     try {
//         const {table, _id} = req.query;
//         // Define mapping for subTables
//         const subTableMap = {
//             "purchae_return_list": "purchae_return_product_list",
//             "quotation_list": "quotation_product_list",
//             "sale_list": "sale_product_list",
//             "sale_return_list": "sale_return_product_list",
//             "purchase_list": "purchase_product_list"
//         };
//         const subTableName = subTableMap[table] || null;

//         if(!table || !_id){
//             return res
//                 .status(internalError)
//                 .json(new ApiError(internalError, "Api Link error"))
//         };

//         // 
//         const sql = `DELETE FROM ${table} WHERE _id='${_id}'`;
//         if(!sql){
//             return res
//                 .status(internalError)
//                 .json(new ApiError(internalError, "server error"))
//         };

//         // 
//         conDB.query(sql, async (err, result)=>{
//             if(err){
//                 return res
//                     .status(internalError)
//                     .json(new ApiError(internalError, "database error", err)) 
//             };
//             //
//             mainTableData = result;
//         });

//         // check can subtable can exist
//         const CanSubTableTrue= allSecendaryBasedTable.filter(each === table);
//         if (CanSubTableTrue) {
//             const subTableName = "?";
//             const sql2 = `DELETE FROM ${subTableName} WHERE tag_id='${_id}'`;
//             conDB.query(sql2, async (err, result2)=>{
//                 if(err){
//                     return res
//                         .status(internalError)
//                         .json(new ApiError(internalError, "database error", err)) 
//                 };
//                 //
//                 subTableData = result2;
//             });
//         };

//         // send Ok data
//         return res
//                 .status(successCode)
//                 .json(new ApiResponse(successCode, result, `This api delete ${table} data`))

//     } catch (err) {
//         return res
//             .status(serverError)
//             .json(new ApiError(serverError, 'Internal Server Error', err.message));
//     }
// });


const TableDataDelete = AsyncHandeler(async (req, res) => {
    try {
        const { table, _id } = req.query;
        if (!table || !_id) {
            return res.status(internalError).json(new ApiError(internalError, "API Link error"));
        };

        // Delete from main table
        const sql = `DELETE FROM ${table} WHERE _id = ?`;
        const [ mainTableData ] = await conDB.promise().query(sql, [_id]);


        // Define mapping for subTables
        const subTableMap = {
            "purchae_return_list": "purchae_return_product_list",
            "purchase_list": "purchase_product_list",
            "quotation_list": "quotation_product_list",
            "sale_list": "sale_product_list",
            "sale_return_list": "sale_return_product_list",
        };
        const subTableName = subTableMap[table] || null;
        
        // If a subTable exists, delete related records
        let subTableData = null;
        if (subTableName) {
            const sql2 = `DELETE FROM ${subTableName} WHERE tag_id = ?`;
            const [ subTableResult ] = await conDB.promise().query(sql2, [_id]);
            subTableData = subTableResult;
        };

        return res
        .status(successCode)
        .json(new ApiResponse(successCode, [ mainTableData, subTableData ],
        `Deleted data from ${table} ${subTableName ? ` and related sub-table ${subTableName}` : ""} `));

    } catch (error) {
        return res.status(serverError).json(new ApiError(serverError, "Internal Server Error", error));
    }
});
module.exports = TableDataDelete;