// 
const { internalError, serverError, successCode } = require("../../controllers/statusCode");
const CURRENTDATE = require("../../controllers/todayDate");
const { AsyncHandeler } = require("../../utils/AsyncHandeller");
const { ApiError } = require("../../utils/ApiError");
const { ApiResponse } = require("../../utils/ApiResponce");
const conDB = require("../../db/database");



const TableName = AsyncHandeler(async(req, res)=>{
    try {
        const {table} = req.query;
        if(!table){
            return res
                .status(internalError)
                .json(new ApiError(internalError, "Api Link error"))
        };

        // 
        const sql = `SELECT * FROM ${table}`;
        if(!sql){
            return res
                .status(internalError)
                .json(new ApiError(internalError, "server error"))
        };

        // 
        conDB.query(sql, async (err, result)=>{
            if(err){
                return res
                    .status(internalError)
                    .json(new ApiError(internalError, "database error", err)) 
            };

            //
            return res
                .status(successCode)
                .json(new ApiResponse(successCode, result, `This api send ${table} Table all data`))

        });

    } catch (err) {
        return res
            .status(serverError)
            .json(new ApiError(serverError, 'Internal Server Error', err.message));
    }
});
module.exports = TableName;