// 
const { internalError, serverError, successCode } = require("../../controllers/statusCode");
const CURRENTDATE = require("../../controllers/todayDate");
const { AsyncHandeler } = require("../../utils/AsyncHandeller");
const { ApiError } = require("../../utils/ApiError");
const { ApiResponse } = require("../../utils/ApiResponce");
const conDB = require("../../db/database");



const Create_user = AsyncHandeler(async(req, res)=>{
    try {
        const {first_name, last_name, password, mobile, user_type, status, address}= req.body;

        if (!first_name || !last_name || !password || !mobile || !user_type || !status || !address) {
            return res.status(internalError).json(new ApiError(internalError, "Give all data", err))
        };

        const randomNumber = Math.floor(Math.random() * (999 - 100 + 1)) + 100;

        async function callDatabase(randomNumber) {

            const full_name= `${first_name} ${last_name}`;
            const user_name = `${last_name}@${randomNumber}`;
            const sql = `INSERT INTO user_info
            (full_name, user_name, password, mobile, user_type, status, address)
            VALUES (?, ?, ?, ?, ?, ?, ?)`;
            const values = [full_name, user_name, password, mobile, user_type, status, address];
            conDB.query(sql, values, async (err, result) => {
                if (err) {
                    if (err?.sqlMessage && err?.sqlMessage.includes(`Duplicate entry '${user_name}'`)) {
                        return callDatabase(randomNumber - 1); // Retry with new number
                    }
                    return res.status(internalError).json(new ApiError(internalError, "Database Problem", err));
                }
                return res.status(successCode).json(new ApiResponse(successCode, result, "Data sent successfully."));
            });

        };

        await callDatabase(randomNumber);  // wait for return

    } catch (error) {
        return res.status().json(new ApiError(serverError, "Server Error", error))
    }
})
module.exports = Create_user;