// 
const { AsyncHandeler } = require("../../utils/AsyncHandeller");
const { ApiError } = require("../../utils/ApiError");
const { ApiResponse } = require("../../utils/ApiResponce");
const conDB = require("../../db/database");
const { internalError, serverError, successCode } = require("../../controllers/statusCode");
const CURRENTDATE = require("../../controllers/todayDate");



                // It's based on payment_list & recived_list table data set

const insert_mode_info = AsyncHandeler(async(req, res)=>{
    try {
        const { table, _id } = req.body;

        if (!table) {
            return res.status(internalError).json(new ApiError(internalError, "Api Data Error", "Table name is required"));
        }

        // identefy sql & values as null
        let sql, values;
        

        if (table === "payment_list") {
            // in this table there are data coloum _id, payment_mode, ledger_name, amount, note, open_date
            const {payment_mode, ledger_name, amount, note, date} = req.body;
            const open_date = date || CURRENTDATE;

            // if _id exist
            if (_id) {
                // Update record if `_id` exists
                sql = `UPDATE payment_list SET payment_mode=?, ledger_name=?, amount=?, note=?, open_date=? WHERE _id=?`;
                values = [payment_mode, ledger_name, amount, note, open_date, _id];
            }
            else{
                // Insert new record if `_id` does not exist
                sql = `INSERT INTO payment_list (payment_mode, ledger_name, amount, note, open_date) VALUES (?, ?, ?, ?, ?)`;
                values = [payment_mode, ledger_name, amount, note, open_date];
            };
        }

        else if(table === "recived_list"){
            // in this table there are data coloum _id, recived_mode, ledger_name, amount, note, open_date
            const {recived_mode, ledger_name, amount, note, date} = req.body;
            const open_date = date || CURRENTDATE;

            // if _id exist
            if (_id) {
                // Update record if `_id` exists
                sql = `UPDATE recived_list SET recived_mode=?, ledger_name=?, amount=?, note=?, open_date=? WHERE _id=?`;
                values = [recived_mode, ledger_name, amount, note, open_date, _id];
            }
            else{
                // Insert new record if `_id` does not exist
                sql = `INSERT INTO recived_list (recived_mode, ledger_name, amount, note, open_date) VALUES (?, ?, ?, ?, ?)`;
                values = [recived_mode, ledger_name, amount, note, open_date];
            };
        }

        else{
            // 
            return res
            .status(internalError)
            .json(new ApiError(internalError, "Api table name Problem", []))
        }

        // Execute SQL Query using Promises
        conDB.query(sql, values, (err, result) => {
            if (err) {
                return res.status(internalError).json(new ApiError(internalError, "Database Error", err));
            }
            return res.status(successCode).json(new ApiResponse(successCode, result, "Data Added successfully"));
        });

    } catch (error) {
        return res.status(serverError).json(new ApiError(serverError, "Internal Server Error", error));
    }
})
module.exports = insert_mode_info;